diff -r b5e1deb7279e src/share/vm/prims/whitebox.cpp
--- a/src/share/vm/prims/whitebox.cpp	Fri May 02 14:53:06 2014 +0200
+++ b/src/share/vm/prims/whitebox.cpp	Wed May 07 20:45:24 2014 +0400
@@ -33,9 +33,11 @@
 #include "prims/whitebox.hpp"
 #include "prims/wbtestmethods/parserTests.hpp"
 
+#include "runtime/thread.hpp"
 #include "runtime/arguments.hpp"
 #include "runtime/interfaceSupport.hpp"
 #include "runtime/os.hpp"
+
 #include "utilities/debug.hpp"
 #include "utilities/macros.hpp"
 #include "utilities/exceptions.hpp"
@@ -574,6 +576,15 @@
 WB_END
 
 
+WB_ENTRY(jlong, WB_GetThreadFullStackSize(JNIEnv* env, jobject o))
+  return (jlong) Thread::current()->stack_size();
+WB_END
+
+WB_ENTRY(jlong, WB_GetThreadRemainingStackSize(JNIEnv* env, jobject o))
+  JavaThread* t = JavaThread::current();
+  return (jlong) ((ptrdiff_t) t->stack_available(os::current_stack_pointer()) - StackShadowPages * os::vm_page_size());
+WB_END
+
 //Some convenience methods to deal with objects from java
 int WhiteBox::offset_for_field(const char* field_name, oop object,
     Symbol* signature_symbol) {
@@ -688,6 +699,8 @@
   {CC"getCPUFeatures",     CC"()Ljava/lang/String;",  (void*)&WB_GetCPUFeatures     },
   {CC"getNMethod",         CC"(Ljava/lang/reflect/Executable;Z)[Ljava/lang/Object;",
                                                       (void*)&WB_GetNMethod         },
+  {CC"getThreadFullStackSize", CC"()J",               (void*)&WB_GetThreadFullStackSize },
+  {CC"getThreadRemainingStackSize", CC"()J",          (void*)&WB_GetThreadRemainingStackSize },
 };
 
 #undef CC
diff -r b5e1deb7279e test/TEST.groups
--- a/test/TEST.groups	Fri May 02 14:53:06 2014 +0200
+++ b/test/TEST.groups	Wed May 07 20:45:24 2014 +0400
@@ -137,7 +137,8 @@
   serviceability/threads/TestFalseDeadLock.java \
   compiler/tiered/NonTieredLevelsTest.java \
   compiler/tiered/TieredLevelsTest.java \
-  compiler/intrinsics/bmi/verifycode
+  compiler/intrinsics/bmi/verifycode \
+  runtime/whitebox/WBStackSize.java
 
 # Compact 2 adds full VM tests
 compact2 = \
diff -r b5e1deb7279e test/runtime/whitebox/WBStackSize.java
--- /dev/null	Thu Jan 01 00:00:00 1970 +0000
+++ b/test/runtime/whitebox/WBStackSize.java	Wed May 07 20:45:24 2014 +0400
@@ -0,0 +1,107 @@
+/*
+ * Copyright (c) 2014, Oracle and/or its affiliates. All rights reserved.
+ * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
+ *
+ * This code is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU General Public License version 2 only, as
+ * published by the Free Software Foundation.
+ *
+ * This code is distributed in the hope that it will be useful, but WITHOUT
+ * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
+ * FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
+ * version 2 for more details (a copy is included in the LICENSE file that
+ * accompanied this code).
+ *
+ * You should have received a copy of the GNU General Public License version
+ * 2 along with this work; if not, write to the Free Software Foundation,
+ * Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA.
+ *
+ * Please contact Oracle, 500 Oracle Parkway, Redwood Shores, CA 94065 USA
+ * or visit www.oracle.com if you need additional information or have any
+ * questions.
+ */
+
+/*
+ * @test WBStackSize
+ * @summary verify that whitebox functions getThreadFullStackSize() and getThreadRemainingStackSize are working
+ * @library /testlibrary /testlibrary/whitebox
+ * @build WBStackSize
+ * @run main ClassFileInstaller sun.hotspot.WhiteBox
+ * @run main/othervm -Xbootclasspath/a:. -XX:+UnlockDiagnosticVMOptions -XX:+WhiteBoxAPI -Xss512k WBStackSize 
+ */
+
+import com.sun.management.HotSpotDiagnosticMXBean;
+import sun.hotspot.WhiteBox;
+
+public class WBStackSize {
+
+    static final long MIN_STACK_SIZE = 8 * 1024;
+    static final long MAX_STACK_SIZE_ALLOCATED_IN_MAIN = 200 * 1024; // current value is about 130k on 64-bit platforms
+
+    static final WhiteBox wb = WhiteBox.getWhiteBox();
+
+    static long stackRemainingSize = -1;
+
+    static int eatAllStack() {
+        return eatAllStack() * 2;
+    }
+    
+    static void testStackOverflow() {
+
+        stackRemainingSize = wb.getThreadRemainingStackSize();
+
+        if (stackRemainingSize > MIN_STACK_SIZE) {
+
+            try {
+                testStackOverflow();
+            } catch (StackOverflowError e) {
+                // We caught SOE too early. The error will be reported in main()
+            }
+
+        } else {
+
+            try {
+                eatAllStack();
+                throw new RuntimeException("Haven't caught StackOverflowError at all. Is 2*2==4 on this machine?");
+            } catch (StackOverflowError e) {
+                // OK: we caught the anticipated error
+            }
+        }
+    }
+
+    public static void main(String[] args) {
+        HotSpotDiagnosticMXBean bean = sun.management.ManagementFactoryHelper.getDiagnosticMXBean();
+        long tss = Long.valueOf(bean.getVMOption("ThreadStackSize").getValue()) * 1024;
+
+        System.out.println("ThreadStackSize VM option = " + tss);
+
+        long fss = wb.getThreadFullStackSize();
+        System.out.println("Full stack size " + fss);
+
+        if (fss < tss * 0.9 || fss > tss * 1.1) {
+            throw new RuntimeException("getThreadFullStackSize value [" + fss 
+                                     + "] should be within 90%..110% of the value returned by HotSpotDiagnosticMXBean");
+        }
+
+        long rss = wb.getThreadRemainingStackSize();
+        System.out.println("Remaining stack size " + rss);
+        
+        // Up to 200k can be already allocated by VM
+        if (rss > tss || (tss > MAX_STACK_SIZE_ALLOCATED_IN_MAIN && rss < tss - MAX_STACK_SIZE_ALLOCATED_IN_MAIN)) {
+            throw new RuntimeException("getThreadRemainingStackSize value [" + rss 
+                                     + "] should be at least ThreadStackSize value [" + tss + "] minus [" 
+                                     + MAX_STACK_SIZE_ALLOCATED_IN_MAIN + "]");
+        }
+
+        testStackOverflow();
+
+        if (stackRemainingSize > MIN_STACK_SIZE) {
+            throw new RuntimeException("Caught StackOverflowError too early: when there were " 
+                                     + stackRemainingSize + " bytes in stack");
+        } else if (stackRemainingSize < 0) {
+            throw new RuntimeException("Internal test error: stackRemainingSize < 0");
+        } else {
+            System.out.println("Caught StackOverflowError as expected");
+        }
+    }
+}
diff -r b5e1deb7279e test/testlibrary/whitebox/sun/hotspot/WhiteBox.java
--- a/test/testlibrary/whitebox/sun/hotspot/WhiteBox.java	Fri May 02 14:53:06 2014 +0200
+++ b/test/testlibrary/whitebox/sun/hotspot/WhiteBox.java	Wed May 07 20:45:24 2014 +0400
@@ -150,6 +150,8 @@
   public native int stressVirtualSpaceResize(long reservedSpaceSize, long magnitude, long iterations);
   public native void runMemoryUnitTests();
   public native void readFromNoaccessArea();
+  public native long getThreadFullStackSize();
+  public native long getThreadRemainingStackSize();
 
   // CPU features
   public native String getCPUFeatures();