diff -r 57bbb66b5f14 experiments/ChartsSampler/src/chartssampler/StackedBarChart.java
--- a/experiments/ChartsSampler/src/chartssampler/StackedBarChart.java	Thu Aug 11 12:23:14 2011 -0700
+++ b/experiments/ChartsSampler/src/chartssampler/StackedBarChart.java	Fri Aug 12 14:26:49 2011 +0200
@@ -44,9 +44,9 @@
 import javafx.animation.KeyValue;
 import javafx.animation.ParallelTransition;
 import javafx.animation.Timeline;
+import javafx.animation.TimelineBuilder;
 import javafx.beans.property.DoubleProperty;
 import javafx.beans.property.SimpleDoubleProperty;
-import javafx.builders.TimelineBuilder;
 import javafx.collections.FXCollections;
 import javafx.collections.ObservableList;
 import javafx.event.ActionEvent;
diff -r 57bbb66b5f14 experiments/Ensemble/src/ensemble/samples/graphics3d/CubeSample.java
--- a/experiments/Ensemble/src/ensemble/samples/graphics3d/CubeSample.java	Thu Aug 11 12:23:14 2011 -0700
+++ b/experiments/Ensemble/src/ensemble/samples/graphics3d/CubeSample.java	Fri Aug 12 14:26:49 2011 +0200
@@ -36,10 +36,10 @@
 import javafx.animation.KeyFrame;
 import javafx.animation.KeyValue;
 import javafx.animation.Timeline;
-import javafx.builders.RectangleBuilder;
 import javafx.scene.Group;
 import javafx.scene.Node;
 import javafx.scene.paint.Color;
+import javafx.scene.shape.RectangleBuilder;
 import javafx.scene.transform.Rotate;
 import javafx.util.Duration;
 
@@ -49,7 +49,7 @@
  *
  * @see javafx.scene.transform.Rotate
  * @see javafx.scene.paint.Color
- * @see javafx.builders.RectangleBuilder
+ * @see javafx.scene.shape.RectangleBuilder
  */
 public class CubeSample extends Sample3D {
 
diff -r 57bbb66b5f14 ga-samples/Ensemble/src/ensemble/samples/charts/custom/AdvStackedBarChartSample.java
--- a/ga-samples/Ensemble/src/ensemble/samples/charts/custom/AdvStackedBarChartSample.java	Thu Aug 11 12:23:14 2011 -0700
+++ b/ga-samples/Ensemble/src/ensemble/samples/charts/custom/AdvStackedBarChartSample.java	Fri Aug 12 14:26:49 2011 +0200
@@ -48,9 +48,9 @@
 import javafx.animation.KeyValue;
 import javafx.animation.ParallelTransition;
 import javafx.animation.Timeline;
+import javafx.animation.TimelineBuilder;
 import javafx.beans.property.DoubleProperty;
 import javafx.beans.property.SimpleDoubleProperty;
-import javafx.builders.TimelineBuilder;
 
 import javafx.collections.FXCollections;
 import javafx.collections.ObservableList;
diff -r 57bbb66b5f14 ga-samples/Ensemble/src/ensemble/samples/graphics/DisplayShelfSample.java
--- a/ga-samples/Ensemble/src/ensemble/samples/graphics/DisplayShelfSample.java	Thu Aug 11 12:23:14 2011 -0700
+++ b/ga-samples/Ensemble/src/ensemble/samples/graphics/DisplayShelfSample.java	Fri Aug 12 14:26:49 2011 +0200
@@ -9,13 +9,13 @@
 import javafx.beans.Observable;
 import javafx.beans.property.DoubleProperty;
 import javafx.beans.property.SimpleDoubleProperty;
-import javafx.builders.ReflectionBuilder;
 import javafx.collections.ObservableList;
 import javafx.event.EventHandler;
 import javafx.scene.Group;
 import javafx.scene.Parent;
 import javafx.scene.control.ScrollBar;
 import javafx.scene.effect.PerspectiveTransform;
+import javafx.scene.effect.ReflectionBuilder;
 import javafx.scene.image.Image;
 import javafx.scene.image.ImageView;
 import javafx.scene.input.KeyCode;
diff -r 57bbb66b5f14 ga-samples/Ensemble/src/ensemble/samples/graphics3d/CubeSample.java
--- a/ga-samples/Ensemble/src/ensemble/samples/graphics3d/CubeSample.java	Thu Aug 11 12:23:14 2011 -0700
+++ b/ga-samples/Ensemble/src/ensemble/samples/graphics3d/CubeSample.java	Fri Aug 12 14:26:49 2011 +0200
@@ -36,10 +36,10 @@
 import javafx.animation.KeyFrame;
 import javafx.animation.KeyValue;
 import javafx.animation.Timeline;
-import javafx.builders.RectangleBuilder;
 import javafx.scene.Group;
 import javafx.scene.Node;
 import javafx.scene.paint.Color;
+import javafx.scene.shape.RectangleBuilder;
 import javafx.scene.transform.Rotate;
 import javafx.util.Duration;
 
@@ -49,7 +49,7 @@
  *
  * @see javafx.scene.transform.Rotate
  * @see javafx.scene.paint.Color
- * @see javafx.builders.RectangleBuilder
+ * @see javafx.scene.shape.RectangleBuilder
  */
 public class CubeSample extends Sample3D {
 
diff -r 57bbb66b5f14 ga-samples/Ensemble/src/ensemble/samples/scenegraph/events/MouseEventsSample.java
--- a/ga-samples/Ensemble/src/ensemble/samples/scenegraph/events/MouseEventsSample.java	Thu Aug 11 12:23:14 2011 -0700
+++ b/ga-samples/Ensemble/src/ensemble/samples/scenegraph/events/MouseEventsSample.java	Fri Aug 12 14:26:49 2011 +0200
@@ -31,8 +31,6 @@
  */
 package ensemble.samples.scenegraph.events;
 
-import javafx.builders.ListViewBuilder;
-import javafx.builders.RectangleBuilder;
 import javafx.event.EventHandler;
 import ensemble.Sample;
 import javafx.collections.FXCollections;
@@ -42,6 +40,7 @@
 import javafx.scene.Group;
 import javafx.scene.Node;
 import javafx.scene.control.ListView;
+import javafx.scene.control.ListViewBuilder;
 import javafx.scene.effect.InnerShadow;
 import javafx.scene.image.Image;
 import javafx.scene.image.ImageView;
@@ -54,6 +53,7 @@
 import javafx.scene.shape.Circle;
 import javafx.scene.shape.Polygon;
 import javafx.scene.shape.Rectangle;
+import javafx.scene.shape.RectangleBuilder;
 
 /**
  * This sample shows different mouse events and their usage: you can drag the circles across the screen, resize them by mouse wheel and see all other mouse events logged in the console
@@ -231,4 +231,4 @@
         return new Group(sample, cursor, mouseRect);
     }
     // END REMOVE ME
-}
\ No newline at end of file
+}
diff -r 57bbb66b5f14 internal/3DTriangles/src/dtriangles/Main.java
--- a/internal/3DTriangles/src/dtriangles/Main.java	Thu Aug 11 12:23:14 2011 -0700
+++ b/internal/3DTriangles/src/dtriangles/Main.java	Fri Aug 12 14:26:49 2011 +0200
@@ -5,9 +5,9 @@
 import dtriangles.shapes3d.Cylinder3D;
 import dtriangles.shapes3d.FancyBar3D;
 import javafx.application.Application;
-import javafx.builders.GroupBuilder;
 import javafx.geometry.Point3D;
 import javafx.scene.Group;
+import javafx.scene.GroupBuilder;
 import javafx.scene.paint.Color;
 import javafx.stage.Stage;
 
diff -r 57bbb66b5f14 internal/3DTriangles/src/dtriangles/shapes3d/faces/TriangleFace.java
--- a/internal/3DTriangles/src/dtriangles/shapes3d/faces/TriangleFace.java	Thu Aug 11 12:23:14 2011 -0700
+++ b/internal/3DTriangles/src/dtriangles/shapes3d/faces/TriangleFace.java	Fri Aug 12 14:26:49 2011 +0200
@@ -2,10 +2,10 @@
 
 
 import dtriangles.Utils;
-import javafx.builders.PolygonBuilder;
 import javafx.geometry.Point3D;
 import javafx.scene.Node;
 import javafx.scene.shape.Polygon;
+import javafx.scene.shape.PolygonBuilder;
 
 
 /**
diff -r 57bbb66b5f14 internal/AddressBookFancy/src/addressbookfancy/CustomerPage.java
--- a/internal/AddressBookFancy/src/addressbookfancy/CustomerPage.java	Thu Aug 11 12:23:14 2011 -0700
+++ b/internal/AddressBookFancy/src/addressbookfancy/CustomerPage.java	Fri Aug 12 14:26:49 2011 +0200
@@ -3,20 +3,20 @@
 
 import bookpanel.Page;
 import javafx.beans.binding.Bindings;
-import javafx.builders.ColumnConstraintsBuilder;
-import javafx.builders.GridPaneBuilder;
-import javafx.builders.TextBuilder;
-import javafx.builders.VBoxBuilder;
 import javafx.geometry.HPos;
 import javafx.geometry.Insets;
 import javafx.geometry.Pos;
 import javafx.geometry.VPos;
 import javafx.scene.image.Image;
 import javafx.scene.image.ImageView;
+import javafx.scene.layout.ColumnConstraintsBuilder;
 import javafx.scene.layout.GridPane;
+import javafx.scene.layout.GridPaneBuilder;
 import javafx.scene.layout.VBox;
+import javafx.scene.layout.VBoxBuilder;
 import javafx.scene.paint.Color;
 import javafx.scene.text.Text;
+import javafx.scene.text.TextBuilder;
 
 
 /**
diff -r 57bbb66b5f14 internal/AddressBookFancy/src/addressbookfancy/Main.java
--- a/internal/AddressBookFancy/src/addressbookfancy/Main.java	Thu Aug 11 12:23:14 2011 -0700
+++ b/internal/AddressBookFancy/src/addressbookfancy/Main.java	Fri Aug 12 14:26:49 2011 +0200
@@ -6,15 +6,15 @@
 import javafx.application.Application;
 import javafx.application.Platform;
 import javafx.async.Task;
-import javafx.builders.SceneBuilder;
-import javafx.builders.StackPaneBuilder;
 import javafx.event.EventHandler;
 import javafx.geometry.Insets;
 import javafx.scene.Group;
 import javafx.scene.Scene;
+import javafx.scene.SceneBuilder;
 import javafx.scene.input.MouseButton;
 import javafx.scene.input.MouseEvent;
 import javafx.scene.layout.Pane;
+import javafx.scene.layout.StackPaneBuilder;
 import javafx.scene.paint.Color;
 import javafx.stage.Stage;
 import javafx.stage.StageStyle;
diff -r 57bbb66b5f14 internal/AddressBookLite/src/addressbooklite/MainJasper.java
--- a/internal/AddressBookLite/src/addressbooklite/MainJasper.java	Thu Aug 11 12:23:14 2011 -0700
+++ b/internal/AddressBookLite/src/addressbooklite/MainJasper.java	Fri Aug 12 14:26:49 2011 +0200
@@ -4,7 +4,6 @@
 import javafx.application.Application;
 import javafx.beans.value.ChangeListener;
 import javafx.beans.value.ObservableValue;
-import javafx.builders.GridPaneBuilder;
 import javafx.collections.FXCollections;
 import javafx.collections.ObservableList;
 import javafx.event.EventHandler;
@@ -20,6 +19,7 @@
 import javafx.scene.control.ListView;
 import javafx.scene.control.SplitPane;
 import javafx.scene.layout.GridPane;
+import javafx.scene.layout.GridPaneBuilder;
 import javafx.scene.layout.StackPane;
 import javafx.stage.Stage;
 
diff -r 57bbb66b5f14 internal/DataApp/DataAppClient/src/com/javafx/experiments/dataapp/client/livetab/LiveMapLocate.java
--- a/internal/DataApp/DataAppClient/src/com/javafx/experiments/dataapp/client/livetab/LiveMapLocate.java	Thu Aug 11 12:23:14 2011 -0700
+++ b/internal/DataApp/DataAppClient/src/com/javafx/experiments/dataapp/client/livetab/LiveMapLocate.java	Fri Aug 12 14:26:49 2011 +0200
@@ -8,15 +8,15 @@
 import javafx.animation.ParallelTransition;
 import javafx.animation.ScaleTransition;
 import javafx.animation.Timeline;
-import javafx.builders.BlendBuilder;
-import javafx.builders.DropShadowBuilder;
 import javafx.event.ActionEvent;
 import javafx.event.EventHandler;
 import javafx.geometry.Bounds;
 import javafx.scene.Group;
+import javafx.scene.effect.BlendBuilder;
 import javafx.scene.effect.BlendMode;
 import javafx.scene.effect.BlurType;
 import javafx.scene.effect.DropShadow;
+import javafx.scene.effect.DropShadowBuilder;
 import javafx.scene.paint.Color;
 import javafx.scene.paint.CycleMethod;
 import javafx.scene.paint.RadialGradient;
diff -r 57bbb66b5f14 internal/EffectsPlayground/src/effectsplayground/Controller.java
--- a/internal/EffectsPlayground/src/effectsplayground/Controller.java	Thu Aug 11 12:23:14 2011 -0700
+++ b/internal/EffectsPlayground/src/effectsplayground/Controller.java	Fri Aug 12 14:26:49 2011 +0200
@@ -6,7 +6,7 @@
 import static effectsplayground.Util.STAGE_HEIGHT;
 import static effectsplayground.Util.STAGE_WIDTH;
 import static effectsplayground.Util.STYLESHEETS;
-import javafx.builders.PauseTransitionBuilder;
+import javafx.animation.PauseTransitionBuilder;
 import javafx.event.ActionEvent;
 import javafx.event.EventHandler;
 import javafx.scene.Cursor;
diff -r 57bbb66b5f14 internal/FXEditor/src/javafx/demo/editor/SelectableEntitiesFactory.java
--- a/internal/FXEditor/src/javafx/demo/editor/SelectableEntitiesFactory.java	Thu Aug 11 12:23:14 2011 -0700
+++ b/internal/FXEditor/src/javafx/demo/editor/SelectableEntitiesFactory.java	Fri Aug 12 14:26:49 2011 +0200
@@ -4,7 +4,6 @@
  */
 package javafx.demo.editor;
 
-import javafx.builders.TextBuilder;
 import javafx.scene.Node;
 import javafx.scene.paint.Color;
 import javafx.scene.shape.Arc;
@@ -15,6 +14,7 @@
 import javafx.scene.shape.StrokeLineCap;
 import javafx.scene.text.Font;
 import javafx.scene.text.Text;
+import javafx.scene.text.TextBuilder;
 
 /**
  *
diff -r 57bbb66b5f14 internal/JiraDashboard/src/com/oracle/jiradashboard/control/ProgressIndicatorNode.java
--- a/internal/JiraDashboard/src/com/oracle/jiradashboard/control/ProgressIndicatorNode.java	Thu Aug 11 12:23:14 2011 -0700
+++ b/internal/JiraDashboard/src/com/oracle/jiradashboard/control/ProgressIndicatorNode.java	Fri Aug 12 14:26:49 2011 +0200
@@ -7,12 +7,12 @@
 
 import javafx.animation.KeyFrame;
 import javafx.animation.KeyValue;
+import javafx.animation.TimelineBuilder;
 import javafx.beans.property.BooleanProperty;
 import javafx.beans.property.DoubleProperty;
 import javafx.beans.property.ObjectProperty;
 import javafx.beans.value.ChangeListener;
 import javafx.beans.value.ObservableValue;
-import javafx.builders.TimelineBuilder;
 import javafx.scene.Node;
 import javafx.scene.control.ProgressIndicator;
 import javafx.scene.layout.StackPane;
diff -r 57bbb66b5f14 internal/JiraDashboard/src/com/oracle/jiradashboard/pages/IssueNode.java
--- a/internal/JiraDashboard/src/com/oracle/jiradashboard/pages/IssueNode.java	Thu Aug 11 12:23:14 2011 -0700
+++ b/internal/JiraDashboard/src/com/oracle/jiradashboard/pages/IssueNode.java	Fri Aug 12 14:26:49 2011 +0200
@@ -5,16 +5,16 @@
 import javafx.beans.property.ObjectProperty;
 import javafx.beans.value.ChangeListener;
 import javafx.beans.value.ObservableValue;
-import javafx.builders.ColumnConstraintsBuilder;
-import javafx.builders.GroupBuilder;
-import javafx.builders.StackPaneBuilder;
 import javafx.scene.Group;
+import javafx.scene.GroupBuilder;
 import javafx.scene.control.Label;
 import javafx.scene.control.OverrunStyle;
 import javafx.scene.layout.ColumnConstraints;
+import javafx.scene.layout.ColumnConstraintsBuilder;
 import javafx.scene.layout.GridPane;
 import javafx.scene.layout.HBox;
 import javafx.scene.layout.StackPane;
+import javafx.scene.layout.StackPaneBuilder;
 import javafx.scene.layout.VBox;
 import javafx.scene.paint.Color;
 import javafx.scene.shape.Rectangle;
@@ -209,4 +209,4 @@
     public void setOnToggle(Runnable onToggle) {
         this.onToggle = onToggle;
     }
-}
\ No newline at end of file
+}
diff -r 57bbb66b5f14 internal/MyPortal/apps/PortraitGallery/src/myportal/plugin/portraitgallery/ui/component/OrgChart.java
--- a/internal/MyPortal/apps/PortraitGallery/src/myportal/plugin/portraitgallery/ui/component/OrgChart.java	Thu Aug 11 12:23:14 2011 -0700
+++ b/internal/MyPortal/apps/PortraitGallery/src/myportal/plugin/portraitgallery/ui/component/OrgChart.java	Fri Aug 12 14:26:49 2011 +0200
@@ -10,7 +10,6 @@
 import javafx.animation.KeyFrame;
 import javafx.animation.KeyValue;
 import javafx.animation.Timeline;
-import javafx.builders.RectangleBuilder;
 import javafx.collections.FXCollections;
 import javafx.collections.ObservableList;
 import javafx.event.ActionEvent;
@@ -24,6 +23,7 @@
 import javafx.scene.shape.MoveTo;
 import javafx.scene.shape.Path;
 import javafx.scene.shape.Rectangle;
+import javafx.scene.shape.RectangleBuilder;
 import javafx.util.Duration;
 import myportal.common.CommonUtil;
 import myportal.common.MouseEventHandler;
diff -r 57bbb66b5f14 internal/PhotoAlbum/src/photoalbum/ui/button/CloseButton.java
--- a/internal/PhotoAlbum/src/photoalbum/ui/button/CloseButton.java	Thu Aug 11 12:23:14 2011 -0700
+++ b/internal/PhotoAlbum/src/photoalbum/ui/button/CloseButton.java	Fri Aug 12 14:26:49 2011 +0200
@@ -6,13 +6,13 @@
 import javafx.application.Platform;
 import javafx.beans.value.ChangeListener;
 import javafx.beans.value.ObservableValue;
-import javafx.builders.LineBuilder;
 import javafx.event.EventHandler;
 import javafx.scene.Cursor;
 import javafx.scene.Parent;
 import javafx.scene.input.MouseEvent;
 import javafx.scene.paint.Color;
 import javafx.scene.shape.Line;
+import javafx.scene.shape.LineBuilder;
 import javafx.scene.shape.Rectangle;
 import photoalbum.Util;
 
diff -r 57bbb66b5f14 internal/PhotoAlbum/src/photoalbum/ui/button/PageButton.java
--- a/internal/PhotoAlbum/src/photoalbum/ui/button/PageButton.java	Thu Aug 11 12:23:14 2011 -0700
+++ b/internal/PhotoAlbum/src/photoalbum/ui/button/PageButton.java	Fri Aug 12 14:26:49 2011 +0200
@@ -6,12 +6,12 @@
 
 import javafx.beans.value.ChangeListener;
 import javafx.beans.value.ObservableValue;
-import javafx.builders.RectangleBuilder;
 import javafx.scene.Cursor;
 import javafx.scene.Parent;
 import javafx.scene.effect.DropShadow;
 import javafx.scene.paint.Color;
 import javafx.scene.shape.Rectangle;
+import javafx.scene.shape.RectangleBuilder;
 
 public class PageButton extends Parent {
 
diff -r 57bbb66b5f14 internal/PhotoAlbum/src/photoalbum/ui/component/DelayPanel.java
--- a/internal/PhotoAlbum/src/photoalbum/ui/component/DelayPanel.java	Thu Aug 11 12:23:14 2011 -0700
+++ b/internal/PhotoAlbum/src/photoalbum/ui/component/DelayPanel.java	Fri Aug 12 14:26:49 2011 +0200
@@ -10,8 +10,6 @@
 import javafx.animation.Timeline;
 import javafx.beans.value.ChangeListener;
 import javafx.beans.value.ObservableValue;
-import javafx.builders.RectangleBuilder;
-import javafx.builders.TextBuilder;
 import javafx.collections.FXCollections;
 import javafx.collections.ObservableList;
 import javafx.event.EventHandler;
@@ -27,8 +25,10 @@
 import javafx.scene.shape.Line;
 import javafx.scene.shape.Polygon;
 import javafx.scene.shape.Rectangle;
+import javafx.scene.shape.RectangleBuilder;
 import javafx.scene.text.Font;
 import javafx.scene.text.Text;
+import javafx.scene.text.TextBuilder;
 import javafx.scene.text.TextBoundsType;
 import javafx.util.Duration;
 import photoalbum.Util;
diff -r 57bbb66b5f14 internal/Xylophone/src/xylophone/Xylophone.java
--- a/internal/Xylophone/src/xylophone/Xylophone.java	Thu Aug 11 12:23:14 2011 -0700
+++ b/internal/Xylophone/src/xylophone/Xylophone.java	Fri Aug 12 14:26:49 2011 +0200
@@ -4,7 +4,6 @@
 package xylophone;
 
 import javafx.application.Application;
-import javafx.builders.RectangleBuilder;
 import javafx.event.EventHandler;
 import javafx.geometry.Bounds;
 import javafx.scene.DepthTest;
@@ -20,6 +19,7 @@
 import javafx.scene.paint.RadialGradient;
 import javafx.scene.paint.Stop;
 import javafx.scene.shape.Rectangle;
+import javafx.scene.shape.RectangleBuilder;
 import javafx.scene.transform.Rotate;
 import javafx.scene.transform.Scale;
 import javafx.scene.transform.Translate;