diff -r c797c08e636a performance/Controls/src/controls/CheckboxTest.java
--- a/performance/Controls/src/controls/CheckboxTest.java	Thu Aug 11 17:45:30 2011 -0700
+++ b/performance/Controls/src/controls/CheckboxTest.java	Fri Aug 12 14:26:51 2011 +0200
@@ -8,6 +8,7 @@
 import java.text.NumberFormat;
 import javafx.animation.KeyFrame;
 import javafx.animation.Timeline;
+import javafx.animation.TimelineBuilder;
 import javafx.application.Application;
 import javafx.application.Platform;
 import javafx.beans.value.ChangeListener;
@@ -20,10 +21,9 @@
 import javafx.scene.input.KeyCode;
 import javafx.scene.input.KeyEvent;
 import javafx.stage.Stage;
+import javafx.stage.StageBuilder;
 import javafx.stage.WindowEvent;
 import javafx.util.Duration;
-import javafx.builders.TimelineBuilder;
-import javafx.builders.StageBuilder;
 
 import java.util.*;
 
diff -r c797c08e636a performance/Controls/src/controls/ListViewTest.java
--- a/performance/Controls/src/controls/ListViewTest.java	Thu Aug 11 17:45:30 2011 -0700
+++ b/performance/Controls/src/controls/ListViewTest.java	Fri Aug 12 14:26:51 2011 +0200
@@ -6,10 +6,9 @@
 import com.sun.javafx.perf.PerformanceTracker;
 import javafx.animation.KeyFrame;
 import javafx.animation.Timeline;
+import javafx.animation.TimelineBuilder;
 import javafx.application.Application;
 import javafx.application.Platform;
-import javafx.builders.StageBuilder;
-import javafx.builders.TimelineBuilder;
 import javafx.collections.FXCollections;
 import javafx.collections.ObservableList;
 import javafx.event.ActionEvent;
@@ -23,6 +22,7 @@
 import javafx.scene.input.MouseButton;
 import javafx.scene.input.MouseEvent;
 import javafx.stage.Stage;
+import javafx.stage.StageBuilder;
 import javafx.stage.WindowEvent;
 import javafx.util.Duration;
 
diff -r c797c08e636a performance/Controls/src/controls/RadioButtonTest.java
--- a/performance/Controls/src/controls/RadioButtonTest.java	Thu Aug 11 17:45:30 2011 -0700
+++ b/performance/Controls/src/controls/RadioButtonTest.java	Fri Aug 12 14:26:51 2011 +0200
@@ -10,6 +10,7 @@
 import java.text.NumberFormat;
 import javafx.animation.KeyFrame;
 import javafx.animation.Timeline;
+import javafx.animation.TimelineBuilder;
 import javafx.application.Application;
 import javafx.application.Platform;
 import javafx.beans.value.ChangeListener;
@@ -23,10 +24,9 @@
 import javafx.scene.input.KeyCode;
 import javafx.scene.input.KeyEvent;
 import javafx.stage.Stage;
+import javafx.stage.StageBuilder;
 import javafx.stage.WindowEvent;
 import javafx.util.Duration;
-import javafx.builders.TimelineBuilder;
-import javafx.builders.StageBuilder;
 import jrockit.bm.util.TestResult;
 
 import java.util.*;
diff -r c797c08e636a performance/Controls/src/controls/TableViewTest.java
--- a/performance/Controls/src/controls/TableViewTest.java	Thu Aug 11 17:45:30 2011 -0700
+++ b/performance/Controls/src/controls/TableViewTest.java	Fri Aug 12 14:26:51 2011 +0200
@@ -6,10 +6,9 @@
 import com.sun.javafx.perf.PerformanceTracker;
 import javafx.animation.KeyFrame;
 import javafx.animation.Timeline;
+import javafx.animation.TimelineBuilder;
 import javafx.application.Application;
 import javafx.application.Platform;
-import javafx.builders.StageBuilder;
-import javafx.builders.TimelineBuilder;
 import javafx.collections.FXCollections;
 import javafx.collections.ObservableList;
 import javafx.event.ActionEvent;
@@ -22,6 +21,7 @@
 import javafx.scene.input.MouseButton;
 import javafx.scene.input.MouseEvent;
 import javafx.stage.Stage;
+import javafx.stage.StageBuilder;
 import javafx.stage.WindowEvent;
 import javafx.util.Callback;
 import javafx.util.Duration;
diff -r c797c08e636a performance/Controls/src/controls/TextBoxTest.java
--- a/performance/Controls/src/controls/TextBoxTest.java	Thu Aug 11 17:45:30 2011 -0700
+++ b/performance/Controls/src/controls/TextBoxTest.java	Fri Aug 12 14:26:51 2011 +0200
@@ -13,8 +13,8 @@
 import javafx.util.Duration;
 import javafx.animation.KeyFrame;
 import javafx.animation.Timeline;
+import javafx.animation.TimelineBuilder;
 import javafx.geometry.Bounds;
-import javafx.builders.TimelineBuilder;
 import fx.bm.FXTest;
 import fx.bm.util.counters.CounterType;
 
diff -r c797c08e636a performance/Controls/src/controls/TextFieldTest.java
--- a/performance/Controls/src/controls/TextFieldTest.java	Thu Aug 11 17:45:30 2011 -0700
+++ b/performance/Controls/src/controls/TextFieldTest.java	Fri Aug 12 14:26:51 2011 +0200
@@ -5,8 +5,8 @@
 import fx.bm.util.counters.CounterType;
 import javafx.animation.KeyFrame;
 import javafx.animation.Timeline;
+import javafx.animation.TimelineBuilder;
 import javafx.application.Application;
-import javafx.builders.TimelineBuilder;
 import javafx.event.ActionEvent;
 import javafx.event.EventHandler;
 import javafx.scene.Group;
diff -r c797c08e636a performance/Controls/src/controls/TreeViewTest.java
--- a/performance/Controls/src/controls/TreeViewTest.java	Thu Aug 11 17:45:30 2011 -0700
+++ b/performance/Controls/src/controls/TreeViewTest.java	Fri Aug 12 14:26:51 2011 +0200
@@ -8,6 +8,7 @@
 import fx.bm.util.counters.CounterType;
 import javafx.animation.KeyFrame;
 import javafx.animation.Timeline;
+import javafx.animation.TimelineBuilder;
 import javafx.application.Application;
 import javafx.application.Platform;
 import javafx.event.ActionEvent;
@@ -22,10 +23,9 @@
 import javafx.scene.control.Button;
 import javafx.scene.control.Label;
 import javafx.stage.Stage;
+import javafx.stage.StageBuilder;
 import javafx.stage.WindowEvent;
 import javafx.util.Duration;
-import javafx.builders.StageBuilder;
-import javafx.builders.TimelineBuilder;
 import jrockit.bm.util.TestResult;
 
 import java.util.EnumSet;
diff -r c797c08e636a performance/DirtyArea/src/dirtyarea/DirtyAreaTest.java
--- a/performance/DirtyArea/src/dirtyarea/DirtyAreaTest.java	Thu Aug 11 17:45:30 2011 -0700
+++ b/performance/DirtyArea/src/dirtyarea/DirtyAreaTest.java	Fri Aug 12 14:26:51 2011 +0200
@@ -13,7 +13,6 @@
 import javafx.scene.shape.*;
 import javafx.util.Duration;
 import javafx.scene.control.*;
-import javafx.builders.*;
 import javafx.scene.text.*;
 import javafx.geometry.Bounds;
 import javafx.geometry.VPos;
diff -r c797c08e636a performance/DirtyArea/src/dirtyarea/node/NodeType01.java
--- a/performance/DirtyArea/src/dirtyarea/node/NodeType01.java	Thu Aug 11 17:45:30 2011 -0700
+++ b/performance/DirtyArea/src/dirtyarea/node/NodeType01.java	Fri Aug 12 14:26:51 2011 +0200
@@ -1,7 +1,6 @@
 package dirtyarea.node;
 
 import javafx.scene.paint.*;
-import javafx.builders.*;
 import javafx.scene.text.*;
 import javafx.geometry.*;
 import javafx.scene.*;
diff -r c797c08e636a performance/DirtyArea/src/dirtyarea/node/NodeType02.java
--- a/performance/DirtyArea/src/dirtyarea/node/NodeType02.java	Thu Aug 11 17:45:30 2011 -0700
+++ b/performance/DirtyArea/src/dirtyarea/node/NodeType02.java	Fri Aug 12 14:26:51 2011 +0200
@@ -1,7 +1,6 @@
 package dirtyarea.node;
 
 import javafx.scene.paint.*;
-import javafx.builders.*;
 import javafx.scene.text.*;
 import javafx.geometry.*;
 import javafx.scene.*;
@@ -34,4 +33,4 @@
         shape.setCenterY(r);
         getChildren().add(shape);
     }
-}
\ No newline at end of file
+}
diff -r c797c08e636a performance/DirtyArea/src/dirtyarea/node/NodeType03.java
--- a/performance/DirtyArea/src/dirtyarea/node/NodeType03.java	Thu Aug 11 17:45:30 2011 -0700
+++ b/performance/DirtyArea/src/dirtyarea/node/NodeType03.java	Fri Aug 12 14:26:51 2011 +0200
@@ -1,7 +1,6 @@
 package dirtyarea.node;
 
 import javafx.scene.paint.*;
-import javafx.builders.*;
 import javafx.scene.text.*;
 import javafx.geometry.*;
 import javafx.scene.*;
diff -r c797c08e636a performance/DirtyArea/src/dirtyarea/node/NodeType04.java
--- a/performance/DirtyArea/src/dirtyarea/node/NodeType04.java	Thu Aug 11 17:45:30 2011 -0700
+++ b/performance/DirtyArea/src/dirtyarea/node/NodeType04.java	Fri Aug 12 14:26:51 2011 +0200
@@ -1,7 +1,6 @@
 package dirtyarea.node;
 
 import javafx.scene.paint.*;
-import javafx.builders.*;
 import javafx.scene.text.*;
 import javafx.geometry.*;
 import javafx.scene.*;
@@ -43,4 +42,4 @@
         tt.relocate((size - bounds.getWidth())/2, (size - bounds.getHeight())/2);
         getChildren().add(tt);
     }
-}
\ No newline at end of file
+}
diff -r c797c08e636a performance/DirtyArea/src/dirtyarea/node/NodeType05.java
--- a/performance/DirtyArea/src/dirtyarea/node/NodeType05.java	Thu Aug 11 17:45:30 2011 -0700
+++ b/performance/DirtyArea/src/dirtyarea/node/NodeType05.java	Fri Aug 12 14:26:51 2011 +0200
@@ -1,7 +1,6 @@
 package dirtyarea.node;
 
 import javafx.scene.paint.*;
-import javafx.builders.*;
 import javafx.scene.text.*;
 import javafx.geometry.*;
 import javafx.scene.*;
diff -r c797c08e636a performance/DirtyArea/src/dirtyarea/node/NodeType06.java
--- a/performance/DirtyArea/src/dirtyarea/node/NodeType06.java	Thu Aug 11 17:45:30 2011 -0700
+++ b/performance/DirtyArea/src/dirtyarea/node/NodeType06.java	Fri Aug 12 14:26:51 2011 +0200
@@ -1,7 +1,6 @@
 package dirtyarea.node;
 
 import javafx.scene.paint.*;
-import javafx.builders.*;
 import javafx.scene.text.*;
 import javafx.geometry.*;
 import javafx.scene.*;
diff -r c797c08e636a performance/SDKSizeAnalyzer/src/com/oracle/fxanalyzer/StackedBarChart.java
--- a/performance/SDKSizeAnalyzer/src/com/oracle/fxanalyzer/StackedBarChart.java	Thu Aug 11 17:45:30 2011 -0700
+++ b/performance/SDKSizeAnalyzer/src/com/oracle/fxanalyzer/StackedBarChart.java	Fri Aug 12 14:26:51 2011 +0200
@@ -12,9 +12,9 @@
 import javafx.animation.KeyValue;
 import javafx.animation.ParallelTransition;
 import javafx.animation.Timeline;
+import javafx.animation.TimelineBuilder;
 import javafx.beans.property.DoubleProperty;
 import javafx.beans.property.SimpleDoubleProperty;
-import javafx.builders.TimelineBuilder;
 import javafx.collections.FXCollections;
 import javafx.collections.ObservableList;
 import javafx.event.ActionEvent;
diff -r c797c08e636a performance/SDKSizeAnalyzer/src/com/oracle/fxanalyzer/data/Component.java
--- a/performance/SDKSizeAnalyzer/src/com/oracle/fxanalyzer/data/Component.java	Thu Aug 11 17:45:30 2011 -0700
+++ b/performance/SDKSizeAnalyzer/src/com/oracle/fxanalyzer/data/Component.java	Fri Aug 12 14:26:51 2011 +0200
@@ -11,7 +11,6 @@
             "javafx/animation.*"
     ),
     Builders(
-            "javafx/builders"
     ),
     CoreLibs(
             "com/sun/javafx/application",