diff -r 06bcd7bf3756 javafx-anim/test/unit/javafx/animation/TimelineTest.java
--- a/javafx-anim/test/unit/javafx/animation/TimelineTest.java	Fri Aug 12 13:33:53 2011 +0400
+++ b/javafx-anim/test/unit/javafx/animation/TimelineTest.java	Fri Aug 12 14:26:50 2011 +0200
@@ -13,7 +13,6 @@
 import java.util.Collections;
 
 import javafx.animation.Animation.Status;
-import javafx.builders.TimelineBuilder;
 import javafx.util.Duration;
 
 import org.junit.Before;
diff -r 06bcd7bf3756 javafx-annotation-processor/src/javafx/builder/processor/BuilderProcessor.java
--- a/javafx-annotation-processor/src/javafx/builder/processor/BuilderProcessor.java	Fri Aug 12 13:33:53 2011 +0400
+++ b/javafx-annotation-processor/src/javafx/builder/processor/BuilderProcessor.java	Fri Aug 12 14:26:50 2011 +0200
@@ -61,11 +61,10 @@
  *
  * <p>The output class is determined by -Ajavafx.builders.output, which is a replacement pattern where
  * $1 $2 etc refer to corresponding parenthesized groups in javafx.builders.input and $0 refers to the
- * entire class name.  The default javafx.builders.input is {@code javafx\\..*\\.(.*)} and the default
- * javafx.builders.output is {@code javafx.builders.$1Builder}, so all builders go in the javafx.builders
- * package, with the builder for javafx.scene.shape.Rectangle being javafx.builders.RectangleBuilder,
- * for example.  If the input were {@code javafx\\..*} and the output {@code $0Builder}, then the
- * builder for javafx.scene.shape.Rectangle would be javafx.scene.shape.RectangleBuilder.</p>
+ * entire class name.  The default javafx.builders.input is {@code (javafx\\..*)} and the default
+ * javafx.builders.output is {@code $1Builder}, so each builder goes in the same package as the class
+ * it builds, with an extra {@code Builder} on the end of its name. For example
+ * the builder for javafx.scene.shape.Rectangle is javafx.scene.shape.RectangleBuilder.</p>
  *
  * @author Eamonn McManus
  */
@@ -83,12 +82,12 @@
     private NoType voidType;
     private PrimitiveType booleanType;
     private Filer filer;
-    private Pattern inputPat = Pattern.compile("javafx\\..*\\.(.*)");
-    private String outputRepl = "javafx.builders.$1Builder";
+    private Pattern inputPat = Pattern.compile("(javafx\\..*)");
+    private String outputRepl = "$1Builder";
     private boolean verbose;
     private TypeMirror rawCollectionType;
     private TypeMirror rawObservableListType;
-    
+
     private final Set<String> builderNames = new HashSet<String>();
 
     private void note(String msg) {
@@ -491,7 +490,7 @@
 
         Map<String, TypeMirror> notBuildable = new TreeMap<String, TypeMirror>(String.CASE_INSENSITIVE_ORDER);
         notBuildable.putAll(scanned.properties);
-        notBuildable.keySet().removeAll(buildablePropertyNames); 
+        notBuildable.keySet().removeAll(buildablePropertyNames);
         notBuildable.keySet().removeAll(scanned.inheritedProperties());
 
         if (type.getAnnotation(NoBuilder.class) != null) {
@@ -687,7 +686,7 @@
 
         final List<String> setters = new ArrayList<String>(buildableProperties.keySet());
         setters.removeAll(scanned.constructorProperties.keySet());
-        
+
         vars.put("classjavadoc", "Builder class for " + type.getQualifiedName());
 
         List<String> lines = rewrite(vars,
@@ -753,7 +752,7 @@
             }
             vars.put("treatasprivate", pName.startsWith("impl_") ? "@treatasprivate " : "");
             lines.addAll(rewrite(vars,
-                    "private {pType} {pName}{init};", 
+                    "private {pType} {pName}{init};",
                     "/**",
                     "  " + initializingmethodComment,
                     "   {treatasprivate}",
diff -r 06bcd7bf3756 javafx-fxml/src/javafx/fxml/JavaFXBuilderFactory.java
--- a/javafx-fxml/src/javafx/fxml/JavaFXBuilderFactory.java	Fri Aug 12 13:33:53 2011 +0400
+++ b/javafx-fxml/src/javafx/fxml/JavaFXBuilderFactory.java	Fri Aug 12 14:26:50 2011 +0200
@@ -18,8 +18,6 @@
  * @treatasprivate
  */
 public final class JavaFXBuilderFactory implements BuilderFactory {
-    private static final String BUILDER_PACKAGE = "javafx.builders.";
-
     private final JavaFXBuilder NO_BUILDER = new JavaFXBuilder();
 
     private final Map<Class<?>, JavaFXBuilder> builders = new HashMap<Class<?>, JavaFXBuilder>();
@@ -86,7 +84,7 @@
 
     JavaFXBuilder createTypeBuilder(Class<?> type) throws ClassNotFoundException {
         JavaFXBuilder typeBuilder = null;
-        Class<?> builderClass = FXMLLoader.loadType(BUILDER_PACKAGE + type.getSimpleName() + "Builder");
+        Class<?> builderClass = FXMLLoader.loadType(type.getName() + "Builder");
         try {
             typeBuilder = new JavaFXBuilder(builderClass);
         } catch (Exception ex) {
diff -r 06bcd7bf3756 javafx-ui-common/test/unit/javafx/scene/paint/ColorTest.java
--- a/javafx-ui-common/test/unit/javafx/scene/paint/ColorTest.java	Fri Aug 12 13:33:53 2011 +0400
+++ b/javafx-ui-common/test/unit/javafx/scene/paint/ColorTest.java	Fri Aug 12 14:26:50 2011 +0200
@@ -11,7 +11,6 @@
 import static org.junit.Assert.assertNotNull;
 import static org.junit.Assert.assertTrue;
 import javafx.animation.Interpolatable;
-import javafx.builders.ColorBuilder;
 
 import org.junit.Test;
 
diff -r 06bcd7bf3756 javafx-ui-common/test/unit/javafx/scene/paint/RadialGradientTest.java
--- a/javafx-ui-common/test/unit/javafx/scene/paint/RadialGradientTest.java	Fri Aug 12 13:33:53 2011 +0400
+++ b/javafx-ui-common/test/unit/javafx/scene/paint/RadialGradientTest.java	Fri Aug 12 14:26:50 2011 +0200
@@ -15,9 +15,6 @@
 import java.util.Arrays;
 import java.util.List;
 
-import javafx.builders.RadialGradientBuilder;
-import javafx.builders.StopBuilder;
-
 import org.junit.Test;
 
 public class RadialGradientTest {
diff -r 06bcd7bf3756 javafx-ui-common/test/unit/javafx/scene/shape/RectangleTest.java
--- a/javafx-ui-common/test/unit/javafx/scene/shape/RectangleTest.java	Fri Aug 12 13:33:53 2011 +0400
+++ b/javafx-ui-common/test/unit/javafx/scene/shape/RectangleTest.java	Fri Aug 12 14:26:50 2011 +0200
@@ -6,7 +6,6 @@
 
 import static org.junit.Assert.assertEquals;
 import static org.junit.Assert.assertSame;
-import javafx.builders.RectangleBuilder;
 import javafx.scene.NodeTest;
 import javafx.scene.paint.Color;
 
diff -r 06bcd7bf3756 javafx-ui-common/test/unit/javafx/scene/shape/ShapeTest.java
--- a/javafx-ui-common/test/unit/javafx/scene/shape/ShapeTest.java	Fri Aug 12 13:33:53 2011 +0400
+++ b/javafx-ui-common/test/unit/javafx/scene/shape/ShapeTest.java	Fri Aug 12 14:26:50 2011 +0200
@@ -4,10 +4,10 @@
 
 package javafx.scene.shape;
 
-import javafx.builders.LineBuilder;
-import javafx.builders.RectangleBuilder;
 import javafx.scene.NodeTest;
 import javafx.scene.paint.Color;
+import javafx.scene.shape.LineBuilder;
+import javafx.scene.shape.RectangleBuilder;
 
 import org.junit.Test;
 
diff -r 06bcd7bf3756 javafx-ui-common/test/unit/javafx/stage/StageTest.java
--- a/javafx-ui-common/test/unit/javafx/stage/StageTest.java	Fri Aug 12 13:33:53 2011 +0400
+++ b/javafx-ui-common/test/unit/javafx/stage/StageTest.java	Fri Aug 12 14:26:50 2011 +0200
@@ -3,10 +3,10 @@
 import static junit.framework.Assert.assertEquals;
 import static junit.framework.Assert.assertFalse;
 import static junit.framework.Assert.assertSame;
-import javafx.builders.StageBuilder;
 import javafx.scene.Group;
 import javafx.scene.Scene;
 import javafx.scene.image.Image;
+import javafx.stage.StageBuilder;
 
 import org.junit.After;
 import org.junit.Before;
diff -r 06bcd7bf3756 toys/ColorCube/src/colorcube/ColorCube.java
--- a/toys/ColorCube/src/colorcube/ColorCube.java	Fri Aug 12 13:33:53 2011 +0400
+++ b/toys/ColorCube/src/colorcube/ColorCube.java	Fri Aug 12 14:26:50 2011 +0200
@@ -6,12 +6,11 @@
 import javafx.animation.KeyFrame;
 import javafx.animation.KeyValue;
 import javafx.animation.Timeline;
+import javafx.animation.TimelineBuilder;
 import javafx.application.Application;
-import javafx.builders.GroupBuilder;
-import javafx.builders.TimelineBuilder;
-import javafx.builders.RectangleBuilder;
 import javafx.geometry.Point3D;
 import javafx.scene.Group;
+import javafx.scene.GroupBuilder;
 import javafx.scene.Node;
 import javafx.scene.PerspectiveCamera;
 import javafx.scene.Scene;
@@ -21,6 +20,7 @@
 import javafx.scene.paint.LinearGradient;
 import javafx.scene.paint.Stop;
 import javafx.scene.shape.Rectangle;
+import javafx.scene.shape.RectangleBuilder;
 import javafx.util.Duration;
 import static javafx.scene.transform.Rotate.*;
 import javafx.stage.Stage;
diff -r 06bcd7bf3756 toys/ColorCube/src/colorcube/JFXPanelColorCube.java
--- a/toys/ColorCube/src/colorcube/JFXPanelColorCube.java	Fri Aug 12 13:33:53 2011 +0400
+++ b/toys/ColorCube/src/colorcube/JFXPanelColorCube.java	Fri Aug 12 14:26:50 2011 +0200
@@ -4,7 +4,6 @@
 
 package colorcube;
 
-import javafx.builders.TimelineBuilder;
 import javafx.scene.paint.Stop;
 import javafx.scene.paint.CycleMethod;
 import javafx.scene.paint.LinearGradient;
@@ -12,7 +11,6 @@
 import javafx.animation.Animation.Status;
 import javafx.scene.input.KeyEvent;
 import javafx.event.EventHandler;
-import javafx.builders.GroupBuilder;
 import javafx.scene.Node;
 import java.util.ArrayList;
 import java.awt.BorderLayout;
@@ -21,14 +19,16 @@
 import javafx.animation.KeyFrame;
 import javafx.animation.KeyValue;
 import javafx.animation.Timeline;
+import javafx.animation.TimelineBuilder;
 import javafx.application.Platform;
-import javafx.builders.RectangleBuilder;
 import javafx.embed.swing.JFXPanel;
 import javafx.geometry.Point3D;
 import javafx.scene.Group;
+import javafx.scene.GroupBuilder;
 import javafx.scene.Scene;
 import javafx.scene.paint.Color;
 import javafx.scene.shape.Rectangle;
+import javafx.scene.shape.RectangleBuilder;
 import javafx.util.Duration;
 import javax.swing.JButton;
 import javax.swing.JFrame;
diff -r 06bcd7bf3756 toys/HelloWorld/src/helloworld/HelloRenderToImage2.java
--- a/toys/HelloWorld/src/helloworld/HelloRenderToImage2.java	Fri Aug 12 13:33:53 2011 +0400
+++ b/toys/HelloWorld/src/helloworld/HelloRenderToImage2.java	Fri Aug 12 14:26:50 2011 +0200
@@ -5,7 +5,6 @@
 package helloworld;
 
 import javafx.application.Application;
-import javafx.builders.SceneBuilder;
 import javafx.scene.Group;
 import javafx.scene.Scene;
 import javafx.scene.image.Image;
diff -r 06bcd7bf3756 toys/HelloWorld/src/helloworld/HelloRenderToImage3.java
--- a/toys/HelloWorld/src/helloworld/HelloRenderToImage3.java	Fri Aug 12 13:33:53 2011 +0400
+++ b/toys/HelloWorld/src/helloworld/HelloRenderToImage3.java	Fri Aug 12 14:26:50 2011 +0200
@@ -5,7 +5,6 @@
 package helloworld;
 
 import javafx.application.Application;
-import javafx.builders.SceneBuilder;
 import javafx.event.ActionEvent;
 import javafx.event.EventHandler;
 import javafx.scene.Group;
diff -r 06bcd7bf3756 toys/HelloWorld/src/helloworld/HelloSplitPane.java
--- a/toys/HelloWorld/src/helloworld/HelloSplitPane.java	Fri Aug 12 13:33:53 2011 +0400
+++ b/toys/HelloWorld/src/helloworld/HelloSplitPane.java	Fri Aug 12 14:26:50 2011 +0200
@@ -7,7 +7,6 @@
 import javafx.application.Application;
 import javafx.beans.InvalidationListener;
 import javafx.beans.Observable;
-import javafx.builders.VBoxBuilder;
 import javafx.event.EventHandler;
 import javafx.geometry.Orientation;
 import javafx.geometry.Pos;
@@ -19,6 +18,7 @@
 import javafx.scene.input.MouseEvent;
 import javafx.scene.layout.HBox;
 import javafx.scene.layout.VBox;
+import javafx.scene.layout.VBoxBuilder;
 import javafx.scene.paint.Color;
 import javafx.stage.Stage;
 
diff -r 06bcd7bf3756 toys/VideoCube/src/videocube/VideoCube.java
--- a/toys/VideoCube/src/videocube/VideoCube.java	Fri Aug 12 13:33:53 2011 +0400
+++ b/toys/VideoCube/src/videocube/VideoCube.java	Fri Aug 12 14:26:50 2011 +0200
@@ -4,7 +4,6 @@
 import java.util.ArrayList;
 import javafx.animation.*;
 import javafx.application.Application;
-import javafx.builders.*;
 import javafx.geometry.*;
 import javafx.util.Duration;
 import javafx.scene.*;