diff -r ceaff1d42882 tests/src/com/sun/media/jfxmediaimpl/PlayerStateListenerImpl.java
--- a/tests/src/com/sun/media/jfxmediaimpl/PlayerStateListenerImpl.java	Fri Aug 12 17:00:55 2011 -0700
+++ b/tests/src/com/sun/media/jfxmediaimpl/PlayerStateListenerImpl.java	Mon Aug 15 11:46:14 2011 -0700
@@ -32,8 +32,8 @@
         }
     }
 
-    public synchronized void onPlay(PlayerStateEvent evt) {
-        System.out.println("onPlay");
+    public synchronized void onPlaying(PlayerStateEvent evt) {
+        System.out.println("onPlaying");
         if (evt.getState() == waitState) {
             state = evt.getState();
             notify();
diff -r ceaff1d42882 tests/src/mts/java/MockPlayerStateListener.java
--- a/tests/src/mts/java/MockPlayerStateListener.java	Fri Aug 12 17:00:55 2011 -0700
+++ b/tests/src/mts/java/MockPlayerStateListener.java	Mon Aug 15 11:46:14 2011 -0700
@@ -50,8 +50,8 @@
         onEvent("onReady", PlayerState.READY, evt);
     }
 
-    public void onPlay(PlayerStateEvent evt) {
-        onEvent("onPlay", PlayerState.PLAYING, evt);
+    public void onPlaying(PlayerStateEvent evt) {
+        onEvent("onPlaying", PlayerState.PLAYING, evt);
     }
 
     public void onPause(PlayerStateEvent evt) {
diff -r ceaff1d42882 tests/src/mts/java/automated/BalanceAfterPauseTest.java
--- a/tests/src/mts/java/automated/BalanceAfterPauseTest.java	Fri Aug 12 17:00:55 2011 -0700
+++ b/tests/src/mts/java/automated/BalanceAfterPauseTest.java	Mon Aug 15 11:46:14 2011 -0700
@@ -92,10 +92,10 @@
             }
         });
 
-        player.setOnPlay(new Runnable() {
+        player.setOnPlaying(new Runnable() {
 
             public void run() {
-                System.out.println("onPlay");
+                System.out.println("onPlaying");
 
                 if (stopTimeReached && playerRestarted) {
                     // check balance
diff -r ceaff1d42882 tests/src/mts/java/automated/BalanceAfterSeekTest.java
--- a/tests/src/mts/java/automated/BalanceAfterSeekTest.java	Fri Aug 12 17:00:55 2011 -0700
+++ b/tests/src/mts/java/automated/BalanceAfterSeekTest.java	Mon Aug 15 11:46:14 2011 -0700
@@ -94,10 +94,10 @@
             }
         });
 
-        player.setOnPlay(new Runnable() {
+        player.setOnPlaying(new Runnable() {
 
             public void run() {
-                System.out.println("onPlay");
+                System.out.println("onPlaying");
 
                 if (stopTimeReached && playerRestarted) {
                     // check balance
diff -r ceaff1d42882 tests/src/mts/java/automated/FadeAfterPauseTest.java
--- a/tests/src/mts/java/automated/FadeAfterPauseTest.java	Fri Aug 12 17:00:55 2011 -0700
+++ b/tests/src/mts/java/automated/FadeAfterPauseTest.java	Mon Aug 15 11:46:14 2011 -0700
@@ -93,10 +93,10 @@
             }
         });
 
-        player.setOnPlay(new Runnable() {
+        player.setOnPlaying(new Runnable() {
 
             public void run() {
-                System.out.println("onPlay");
+                System.out.println("onPlaying");
 
                 if (stopTimeReached && playerRestarted) {
 //                    System.out.println("actual fader is: " + player.getFader());
diff -r ceaff1d42882 tests/src/mts/java/automated/FadeAfterSeekTest.java
--- a/tests/src/mts/java/automated/FadeAfterSeekTest.java	Fri Aug 12 17:00:55 2011 -0700
+++ b/tests/src/mts/java/automated/FadeAfterSeekTest.java	Mon Aug 15 11:46:14 2011 -0700
@@ -94,10 +94,10 @@
             }
         });
 
-        player.setOnPlay(new Runnable() {
+        player.setOnPlaying(new Runnable() {
 
             public void run() {
-                System.out.println("onPlay");
+                System.out.println("onPlaying");
 
                 if (stopTimeReached && playerRestarted) {
 //                    System.out.println("actual fader is: " + player.getFader());
diff -r ceaff1d42882 tests/src/mts/java/automated/MuteAfterPauseTest.java
--- a/tests/src/mts/java/automated/MuteAfterPauseTest.java	Fri Aug 12 17:00:55 2011 -0700
+++ b/tests/src/mts/java/automated/MuteAfterPauseTest.java	Mon Aug 15 11:46:14 2011 -0700
@@ -91,10 +91,10 @@
             }
         });
 
-        player.setOnPlay(new Runnable() {
+        player.setOnPlaying(new Runnable() {
 
             public void run() {
-                System.out.println("onPlay");
+                System.out.println("onPlaying");
 
                 if (stopTimeReached && playerRestarted) {
                     boolean actualMuteState = player.isMute();
diff -r ceaff1d42882 tests/src/mts/java/automated/MuteAfterSeekTest.java
--- a/tests/src/mts/java/automated/MuteAfterSeekTest.java	Fri Aug 12 17:00:55 2011 -0700
+++ b/tests/src/mts/java/automated/MuteAfterSeekTest.java	Mon Aug 15 11:46:14 2011 -0700
@@ -94,10 +94,10 @@
             }
         });
 
-        player.setOnPlay(new Runnable() {
+        player.setOnPlaying(new Runnable() {
 
             public void run() {
-                System.out.println("onPlay");
+                System.out.println("onPlaying");
 
                 if (stopTimeReached && playerRestarted) {
                     boolean actualMuteState = player.isMute();
diff -r ceaff1d42882 tests/src/mts/java/automated/RateAfterPauseTest.java
--- a/tests/src/mts/java/automated/RateAfterPauseTest.java	Fri Aug 12 17:00:55 2011 -0700
+++ b/tests/src/mts/java/automated/RateAfterPauseTest.java	Mon Aug 15 11:46:14 2011 -0700
@@ -91,10 +91,10 @@
             }
         });
 
-        player.setOnPlay(new Runnable() {
+        player.setOnPlaying(new Runnable() {
 
             public void run() {
-                System.out.println("onPlay");
+                System.out.println("onPlaying");
 
                 if (stopTimeReached && playerRestarted) {
                     double actualRate = player.getRate();
diff -r ceaff1d42882 tests/src/mts/java/automated/RateAfterSeekTest.java
--- a/tests/src/mts/java/automated/RateAfterSeekTest.java	Fri Aug 12 17:00:55 2011 -0700
+++ b/tests/src/mts/java/automated/RateAfterSeekTest.java	Mon Aug 15 11:46:14 2011 -0700
@@ -95,10 +95,10 @@
             }
         });
 
-        player.setOnPlay(new Runnable() {
+        player.setOnPlaying(new Runnable() {
 
             public void run() {
-                System.out.println("onPlay");
+                System.out.println("onPlaying");
 
                 if (stopTimeReached && seekPerformed) {
                     double actualRate = player.getRate();
diff -r ceaff1d42882 tests/src/mts/java/automated/RepeatTimeIntervalTest.java
--- a/tests/src/mts/java/automated/RepeatTimeIntervalTest.java	Fri Aug 12 17:00:55 2011 -0700
+++ b/tests/src/mts/java/automated/RepeatTimeIntervalTest.java	Mon Aug 15 11:46:14 2011 -0700
@@ -111,7 +111,7 @@
             }
         });
 
-        player.setOnPlay(new Runnable() {
+        player.setOnPlaying(new Runnable() {
             public void run() {
                 if (!playbackStarted) {
                     beginTime = System.currentTimeMillis();
diff -r ceaff1d42882 tests/src/mts/java/automated/SeekTest.java
--- a/tests/src/mts/java/automated/SeekTest.java	Fri Aug 12 17:00:55 2011 -0700
+++ b/tests/src/mts/java/automated/SeekTest.java	Mon Aug 15 11:46:14 2011 -0700
@@ -71,10 +71,10 @@
         player = new MediaPlayer(media);
         player.setAutoPlay(true);
 
-        player.setOnPlay(new Runnable() {
+        player.setOnPlaying(new Runnable() {
 
             public void run() {
-                System.out.println("onPlay");
+                System.out.println("onPlaying");
 
                 KeyFrame keyFrame = new KeyFrame(new Duration(4000), new EventHandler<ActionEvent>() {
 
diff -r ceaff1d42882 tests/src/mts/java/automated/StartTimeNegativeTest.java
--- a/tests/src/mts/java/automated/StartTimeNegativeTest.java	Fri Aug 12 17:00:55 2011 -0700
+++ b/tests/src/mts/java/automated/StartTimeNegativeTest.java	Mon Aug 15 11:46:14 2011 -0700
@@ -74,9 +74,9 @@
         player.setStartTime(new Duration(-8000));
         player.setStopTime(new Duration(duration));
 
-        player.setOnPlay(new Runnable() {
+        player.setOnPlaying(new Runnable() {
             public void run() {
-                System.out.println("onPlay");
+                System.out.println("onPlaying");
 
                 startTimer();
             }
diff -r ceaff1d42882 tests/src/mts/java/automated/StopTimeBeyondDurationTest.java
--- a/tests/src/mts/java/automated/StopTimeBeyondDurationTest.java	Fri Aug 12 17:00:55 2011 -0700
+++ b/tests/src/mts/java/automated/StopTimeBeyondDurationTest.java	Mon Aug 15 11:46:14 2011 -0700
@@ -76,9 +76,9 @@
         player.setStartTime(new Duration(duration - 2000));
         player.setStopTime(new Duration(duration + 8000));
 
-        player.setOnPlay(new Runnable() {
+        player.setOnPlaying(new Runnable() {
             public void run() {
-                System.out.println("onPlay");
+                System.out.println("onPlaying");
                 startTimer();
             }
         });