diff -r e929726de254 javafx-ui-webnode/src/com/sun/javafx/scene/web/skin/HTMLEditorSkin.java
--- a/javafx-ui-webnode/src/com/sun/javafx/scene/web/skin/HTMLEditorSkin.java	Tue Sep 13 10:02:48 2011 -0700
+++ b/javafx-ui-webnode/src/com/sun/javafx/scene/web/skin/HTMLEditorSkin.java	Tue Sep 13 12:37:33 2011 -0700
@@ -48,6 +48,8 @@
 import com.sun.webpane.platform.WebPage;
 import com.sun.webpane.platform.event.WCFocusEvent;
 import com.sun.webpane.sg.Accessor;
+import java.security.AccessController;
+import java.security.PrivilegedAction;
 
 /**
  * HTML editor skin.
@@ -364,55 +366,42 @@
     }
 
     private void populateToolbars() {
-        ResourceBundle resources = ResourceBundle.getBundle(getClass().getName());
+        final ResourceBundle resources = ResourceBundle.getBundle(getClass().getName());
 
         // Toolbar 1
-        cutButton = addButton(toolbar1, getClass().getResource(resources.getString("cutIcon")),
-            resources.getString("cut"), CUT_COMMAND);
-        copyButton = addButton(toolbar1, getClass().getResource(resources.getString("copyIcon")),
-            resources.getString("copy"), COPY_COMMAND);
-        pasteButton = addButton(toolbar1, getClass().getResource(resources.getString("pasteIcon")),
-            resources.getString("paste"), PASTE_COMMAND);
+        cutButton = addButton(toolbar1, resources.getString("cutIcon"), resources.getString("cut"), CUT_COMMAND);
+        copyButton = addButton(toolbar1, resources.getString("copyIcon"), resources.getString("copy"), COPY_COMMAND);
+        pasteButton = addButton(toolbar1, resources.getString("pasteIcon"), resources.getString("paste"), PASTE_COMMAND);
 
         toolbar1.getItems().add(new Separator());
 
-//        undoButton = addButton(toolbar1, getClass().getResource(resources.getString("undoIcon")),
-//            resources.getString("undo"), UNDO_COMMAND);
-//        redoButton = addButton(toolbar1, getClass().getResource(resources.getString("redoIcon")),
-//            resources.getString("redo"), REDO_COMMAND);
+//        undoButton = addButton(toolbar1, "undoIcon", resources.getString("undo"), UNDO_COMMAND);
+//        redoButton = addButton(toolbar1, "redoIcon", resources.getString("redo"), REDO_COMMAND);
 //
 //        toolbar1.getItems().add(new Separator());
 
         alignmentToggleGroup = new ToggleGroup();
         alignLeftButton = addToggleButton(toolbar1, alignmentToggleGroup,
-            getClass().getResource(resources.getString("alignLeftIcon")),
-            resources.getString("alignLeft"), ALIGN_LEFT_COMMAND);
+            resources.getString("alignLeftIcon"), resources.getString("alignLeft"), ALIGN_LEFT_COMMAND);
         alignCenterButton = addToggleButton(toolbar1, alignmentToggleGroup,
-            getClass().getResource(resources.getString("alignCenterIcon")),
-            resources.getString("alignCenter"), ALIGN_CENTER_COMMAND);
+            resources.getString("alignCenterIcon"), resources.getString("alignCenter"), ALIGN_CENTER_COMMAND);
         alignRightButton = addToggleButton(toolbar1, alignmentToggleGroup,
-            getClass().getResource(resources.getString("alignRightIcon")),
-            resources.getString("alignRight"), ALIGN_RIGHT_COMMAND);
+            resources.getString("alignRightIcon"), resources.getString("alignRight"), ALIGN_RIGHT_COMMAND);
         alignJustifyButton = addToggleButton(toolbar1, alignmentToggleGroup,
-            getClass().getResource(resources.getString("alignJustifyIcon")),
-            resources.getString("alignJustify"), ALIGN_JUSTIFY_COMMAND);
+            resources.getString("alignJustifyIcon"), resources.getString("alignJustify"), ALIGN_JUSTIFY_COMMAND);
         
         toolbar1.getItems().add(new Separator());
         
-        outdentButton = addButton(toolbar1, getClass().getResource(resources.getString("outdentIcon")),
-            resources.getString("outdent"), OUTDENT_COMMAND);
-        indentButton = addButton(toolbar1, getClass().getResource(resources.getString("indentIcon")),
-            resources.getString("indent"), INDENT_COMMAND);
+        outdentButton = addButton(toolbar1, resources.getString("outdentIcon"), resources.getString("outdent"), OUTDENT_COMMAND);
+        indentButton = addButton(toolbar1, resources.getString("indentIcon"), resources.getString("indent"), INDENT_COMMAND);
         
         toolbar1.getItems().add(new Separator());
 
         ToggleGroup listStyleToggleGroup = new ToggleGroup();
         bulletsButton = addToggleButton(toolbar1, listStyleToggleGroup,
-            getClass().getResource(resources.getString("bulletsIcon")),
-            resources.getString("bullets"), BULLETS_COMMAND);
+            resources.getString("bulletsIcon"), resources.getString("bullets"), BULLETS_COMMAND);
         numbersButton = addToggleButton(toolbar1, listStyleToggleGroup,
-            getClass().getResource(resources.getString("numbersIcon")),
-            resources.getString("numbers"), NUMBERS_COMMAND);
+            resources.getString("numbersIcon"), resources.getString("numbers"), NUMBERS_COMMAND);
 
         toolbar1.getItems().add(new Separator());
 
@@ -556,21 +545,17 @@
         toolbar2.getItems().add(new Separator());
 
         boldButton = addToggleButton(toolbar2, null,
-            getClass().getResource(resources.getString("boldIcon")),
-            resources.getString("bold"), BOLD_COMMAND);
+            resources.getString("boldIcon"), resources.getString("bold"), BOLD_COMMAND);
         italicButton = addToggleButton(toolbar2, null,
-            getClass().getResource(resources.getString("italicIcon")),
-            resources.getString("italic"), ITALIC_COMMAND);
+            resources.getString("italicIcon"), resources.getString("italic"), ITALIC_COMMAND);
         underlineButton = addToggleButton(toolbar2, null,
-            getClass().getResource(resources.getString("underlineIcon")),
-            resources.getString("underline"), UNDERLINE_COMMAND);
+            resources.getString("underlineIcon"), resources.getString("underline"), UNDERLINE_COMMAND);
         strikethroughButton = addToggleButton(toolbar2, null,
-            getClass().getResource(resources.getString("strikethroughIcon")),
-            resources.getString("strikethrough"), STRIKETHROUGH_COMMAND);
+            resources.getString("strikethroughIcon"), resources.getString("strikethrough"), STRIKETHROUGH_COMMAND);
 
         toolbar2.getItems().add(new Separator());
 
-        insertHorizontalRuleButton = addButton(toolbar2, getClass().getResource(resources.getString("insertHorizontalRuleIcon")),
+        insertHorizontalRuleButton = addButton(toolbar2, resources.getString("insertHorizontalRuleIcon"),
             resources.getString("insertHorizontalRule"), INSERT_HORIZONTAL_RULE_COMMAND);
         // We override setOnAction to insert a new line.  This fixes RT-16453
         insertHorizontalRuleButton.setOnAction(new EventHandler<ActionEvent>() {
@@ -585,8 +570,11 @@
         fgColorButton = new PopupButton();
         fgColorButton.setFocusTraversable(false);
         toolbar1.getItems().add(fgColorButton);
-        URL foregroundIconURL = getClass().getResource(resources.getString("foregroundColorIcon"));
-        Image foregroundIcon = new Image(foregroundIconURL.toString());
+        Image foregroundIcon = AccessController.doPrivileged(new PrivilegedAction<Image>() {
+            @Override public Image run() {
+                return new Image(HTMLEditorSkin.class.getResource(resources.getString("foregroundColorIcon")).toString());
+            }
+        });
         fgColorRect = new Rectangle(0, 10, 16, 5);
         Group fgGroup = new Group();
         fgGroup.getChildren().addAll(fgColorRect, new ImageView(foregroundIcon));
@@ -610,8 +598,11 @@
         bgColorButton = new PopupButton();
         bgColorButton.setFocusTraversable(false);
         toolbar1.getItems().add(bgColorButton);
-        URL backgroundIconURL = getClass().getResource(resources.getString("backgroundColorIcon"));
-        Image backgroundIcon = new Image(backgroundIconURL.toString());
+        Image backgroundIcon = AccessController.doPrivileged(new PrivilegedAction<Image>() {
+            @Override public Image run() {
+                return new Image(HTMLEditorSkin.class.getResource(resources.getString("backgroundColorIcon")).toString());
+            }
+        });
         bgColorRect = new Rectangle(0, 10, 16, 5);
         bgColorRect.setFill(DEFAULT_BG_COLOR);
         Group bgGroup = new Group();
@@ -634,13 +625,17 @@
         });   
     }
 
-    private Button addButton(ToolBar toolbar, URL iconURL, String tooltipText,
+    private Button addButton(ToolBar toolbar, final String iconName, String tooltipText,
         final String command) {
         Button button = new Button();
         button.setFocusTraversable(false);
         toolbar.getItems().add(button);
 
-        Image icon = new Image(iconURL.toString());
+        Image icon = AccessController.doPrivileged(new PrivilegedAction<Image>() {
+            @Override public Image run() {
+                return new Image(HTMLEditorSkin.class.getResource(iconName).toString());
+            }
+        });        
         button.setGraphic(new ImageView(icon));
         button.setTooltip(new Tooltip(tooltipText));
 
@@ -656,14 +651,18 @@
     }
 
     private ToggleButton addToggleButton(ToolBar toolbar, ToggleGroup toggleGroup,
-        URL iconURL, String tooltipText, final String command) {
+        final String iconName, String tooltipText, final String command) {
         ToggleButton toggleButton = new ToggleButton();
         toggleButton.setUserData(command);
         toggleButton.setFocusTraversable(false);
         toolbar.getItems().add(toggleButton);
         toggleButton.setToggleGroup(toggleGroup);
 
-        Image icon = new Image(iconURL.toString());
+        Image icon = AccessController.doPrivileged(new PrivilegedAction<Image>() {
+            @Override public Image run() {
+                return new Image(HTMLEditorSkin.class.getResource(iconName).toString());
+            }
+        });    
         toggleButton.setGraphic(new ImageView(icon));
         toggleButton.setTooltip(new Tooltip(tooltipText));
 
diff -r e929726de254 javafx-ui-webnode/src/javafx/scene/web/HTMLEditor.java
--- a/javafx-ui-webnode/src/javafx/scene/web/HTMLEditor.java	Tue Sep 13 10:02:48 2011 -0700
+++ b/javafx-ui-webnode/src/javafx/scene/web/HTMLEditor.java	Tue Sep 13 12:37:33 2011 -0700
@@ -6,6 +6,8 @@
 
 
 import com.sun.javafx.scene.web.skin.HTMLEditorSkin;
+import java.security.AccessController;
+import java.security.PrivilegedAction;
 
 import javafx.scene.control.Control;
 
@@ -25,7 +27,11 @@
 
     /** {@inheritDoc} */
     @Override protected String getUserAgentStylesheet() {
-        return HTMLEditorSkin.class.getResource("html-editor.css").toExternalForm();
+        return AccessController.doPrivileged(new PrivilegedAction<String>() {
+            @Override public String run() {
+                return HTMLEditorSkin.class.getResource("html-editor.css").toExternalForm();
+            }
+        });         
     }
 
     /**