diff -r 1da14a0e472e packager/src/com/sun/javafx/tools/packager/Bundle.properties
--- a/packager/src/com/sun/javafx/tools/packager/Bundle.properties	Tue Oct 25 17:21:51 2011 -0700
+++ b/packager/src/com/sun/javafx/tools/packager/Bundle.properties	Thu Oct 27 10:56:18 2011 +0200
@@ -13,8 +13,10 @@
 \          Signs jar file(s) with a provided certificate.\n\
 \  -makeall\n\
 \          Performs compilation, createjar and deploy steps as one call with \n\
-\          most arguments predefined (srcdir is src, outdir is dist). Please\n\
-\          set those described in makeAll section below.\
+\          most arguments predefined. The sources must be located in "src"\n\
+\          folder, the resulting files (jar, jnlp, html) are put in "dist"\n\
+\          folder. This command may be configured only in a minimal way and is\n\
+\          as automated as possible.\n\
 \n\
 Options for createjar command include: \n\
 \  -appclass <application class>\n\
@@ -140,6 +142,7 @@
 \          width of the application.\n\
 \  -height <height>\n\
 \          height of the application.\n\
+\  -v      enable verbose output.\n\
 \n\
 Sample usages:\n\
 --------------\n\
@@ -151,7 +154,11 @@
 \  -name AppName -appclass package.class -v -srcdir compiled\n\
 \          Generates outfile.jnlp and corresponding outfile.html files in \n\
 \          outdir for aplication AppName that is started by package.class class\n\
-\          and has dimensions of 34x43.
+\          and has dimensions of 34x43.\n\
+javafxpackager -makeall -appclass brickbreaker.Main -name BrickBreaker\n\
+\  -width 600 -height 600\n\
+\          This command does all the packaging work including compilation: \n\
+\          compile, createJar, deploy.
 
 # TODO missing documentation: dragable, shortcut
 
@@ -172,6 +179,7 @@
 ERR_CantFindRuntime=ERROR: jfxrt.jar needs to be on classpath for -createbss and for -createJar without -nocss2bin
 ERR_CantDeleteFile=ERROR: File {} could not be deleted.
 ERR_MissingDirectory=Missing directory {0}
+ERR_EmptySourceDirectory=Empty source directory {0}
 ERR_MissingJavaHome=ERROR: Java home directory is not known.
 ERR_MissingJavaFxHome=ERROR: JavaFx home directory is not known.
 ERR_JavacFailed=ERROR: javac execution failed, exit code: {0}
diff -r 1da14a0e472e packager/src/com/sun/javafx/tools/packager/Main.java
--- a/packager/src/com/sun/javafx/tools/packager/Main.java	Tue Oct 25 17:21:51 2011 -0700
+++ b/packager/src/com/sun/javafx/tools/packager/Main.java	Thu Oct 27 10:56:18 2011 +0200
@@ -349,6 +349,8 @@
                             makeAllParams.setWidth(Integer.parseInt(nextArg(args, i++)));
                         } else if(arg.equalsIgnoreCase("-height")) {
                             makeAllParams.setHeight(Integer.parseInt(nextArg(args, i++)));
+                        } else if(arg.equalsIgnoreCase("-v")) {
+                            makeAllParams.setVerbose(true);
                         }
                     }
                     makeAll = true;
diff -r 1da14a0e472e packager/src/com/sun/javafx/tools/packager/MakeAllParams.java
--- a/packager/src/com/sun/javafx/tools/packager/MakeAllParams.java	Tue Oct 25 17:21:51 2011 -0700
+++ b/packager/src/com/sun/javafx/tools/packager/MakeAllParams.java	Thu Oct 27 10:56:18 2011 +0200
@@ -11,6 +11,7 @@
     String appName;
     int width;
     int height;
+    boolean verbose = false;
 
     public void setAppClass(String appClass) {
         this.appClass = appClass;
@@ -35,6 +36,10 @@
     public void setWidth(int width) {
         this.width = width;
     }
+    
+    public void setVerbose(boolean verbose) {
+        this.verbose = verbose;
+    }
 
     public void validate() throws PackagerException {
     }
diff -r 1da14a0e472e packager/src/com/sun/javafx/tools/packager/PackagerLib.java
--- a/packager/src/com/sun/javafx/tools/packager/PackagerLib.java	Tue Oct 25 17:21:51 2011 -0700
+++ b/packager/src/com/sun/javafx/tools/packager/PackagerLib.java	Thu Oct 27 10:56:18 2011 +0200
@@ -506,7 +506,16 @@
             } finally {
                 sources.close();
             }
-
+            if (makeAllParams.verbose) {
+                System.out.println("Executing javac:");
+                System.out.format("%s %s %s %s %s %s %s %s %s %s\n",
+                        javac.getAbsolutePath(),
+                        "-target", "1.5",
+                        "-source", "1.5",
+                        "-d", compiledDirName,
+                        "-cp", jfxHome + "/../rt/lib/jfxrt.jar",
+                        "@" + tmpFile.getAbsolutePath());
+            }
             int ret = execute(
                     javac.getAbsolutePath(),
                     "-target", "1.5",
@@ -594,6 +603,9 @@
     private static void scanAndCopy(PackagerResource dir, Writer out, File outdir) throws PackagerException {
         if (!dir.getFile().exists()) {
             throw new PackagerException("ERR_MissingDirectory", dir.getFile().getName());
+        }
+        if ((dir.getFile().listFiles() == null) || (dir.getFile().listFiles().length == 0)) {
+            throw new PackagerException("ERR_EmptySourceDirectory", dir.getFile().getName());
         }
         try {
             for (File f : dir.getFile().listFiles()) {